package de.zuim.ledcontrol;

import de.zuim.ledcontrol.effects.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

public class EffectManager {

    int activeId=4;
    private final LEDEffect[] effects = new LEDEffect[]{new TemperatureEffect(), new ClockEffect(), new SineEffect(), new AudioEffect(), new ColorSweep()};

    public EffectManager(){

        final SystemTray tray = SystemTray.getSystemTray();
        final TrayIcon trayIcon = new TrayIcon(new ImageIcon(getClass().getResource("/icon.png")).getImage(),"LEDEffects");

        trayIcon.addMouseListener(new MouseListener() {
            @Override
            public void mouseClicked(MouseEvent e) {
                if(e.getButton()!=MouseEvent.BUTTON1)
                    System.exit(0);
                getActiveEffect().unload();
                activeId++;
                if(activeId==effects.length)
                    activeId=0;
                getActiveEffect().load();
                trayIcon.setToolTip("LEDEffects - " + getActiveEffect().getDescription());
            }

            @Override
            public void mousePressed(MouseEvent e) {}

            @Override
            public void mouseReleased(MouseEvent e) {}

            @Override
            public void mouseEntered(MouseEvent e) {}

            @Override
            public void mouseExited(MouseEvent e) {}
        });
        try {
            tray.add(trayIcon);
        } catch (AWTException e) {
            e.printStackTrace();
        }

        getActiveEffect().load();
    }

    public LEDEffect getActiveEffect() {
        return effects[activeId];
    }
}
